<?php
/** 
* Class to create additional product panel in admin 
* @package TPWCP 
* ARTURO: V.2 (Linea 179 modificado query para mostrar solo productos que tienen llaves)
* 		  V.2.1 (Combo de 3 Productos)
*/
// Exit if accessed directly 
if( ! defined( 'ABSPATH' ) ) {
    exit;
}
if( ! class_exists( 'WAOLM_Pestania' ) ) {
    class WAOLM_Pestania {
        public function __construct() {
        }
        public function init() {
      	// Create the custom tab 
            add_filter( 'woocommerce_product_data_tabs', array( $this, 'create_autodispatch_tab' ) );
    		// Add the custom fields 
            add_action( 'woocommerce_product_data_panels', array( $this, 'display_autodispatch_fields' ) );
    		// Save the custom fields 
    		add_action( 'woocommerce_process_product_meta', array( $this, 'save_fields' ) );
       }
/** 
* Add the new tab to the $tabs array 
* @see https://github.com/woocommerce/woocommerce/blob/e1a82a412773c932e76b855a97bd5ce9dedf9c44/includes/admin/meta-boxes/class-wc-meta-box-product-data.php 
* @param $tabs 
* @since 1.0.0 
*/
	public function create_autodispatch_tab( $tabs ) {
		$tabs['giftwrap'] = array(
			'label'         => __( 'Automatic Dispatch', 'waolicensemanager' ), // The name of your panel 
			'target'		=> 'gifwrap_panel', // Will be used to create an anchor link so needs to be unique 
			'class'			=> array( 'giftwrap_tab', 'show_if_simple', 'show_if_variable' ), // Class for your panel tab - helps hide/show depending on product type 
			'priority'      => 80, // Where your panel will appear. By default, 70 is last item 
		);
		return $tabs;
	}
/** 
* Display fields for the new panel 
* @see https://docs.woocommerce.com/wc-apidocs/source-function-woocommerce_wp_checkbox.html 
* @since 1.0.0 
*/
	public function display_autodispatch_fields($post_id) { ?>
		<style>
			.inline1{display:inline-block!important;border-right:solid gray 1px;}
			.inline1 ul li{display:inline-block!important}
			.wc-radios li{display:inline!important;padding-left:3px;padding-right:3px;}
			.no-show {display:none!important;}
			.woocommerce_options_panel label{width:300px!important;}
		</style>
		<div id='gifwrap_panel' class='panel woocommerce_options_panel' style='margin-top:1px;'>
			<div class="options_group">
				<div>
				<?php
					$sino=false;
					$name=get_post($post_id);
					$sku=get_post_meta($name->ID,'_sku',true);//nuevo / obtengo el _sku del producto
					$auto=get_post_meta($name->ID,'_autodispatch_option');//del producto
					$co=get_post_meta($name->ID,'_combos_option');
					$combos_option=$co[0]==""?'One':$co[0];
					if($combos_option<>'One'){$clase="inline1 no-show";}else{$clase="inline1";}
					woocommerce_wp_checkbox(
						array(
							'id'		=> 'autodispatch_option',
							'label'		=> __( 'Auto dispatch option', 'waolicensemanager' ),
							'value'		=> $auto[0],
							'wrapper_class'	=> 'inline1',
							'desc_tip'	=> $sino,
							'descriptionx'	=> __( 'Select this option to activate keys autodispatch for this product', 'waolicensemanager' )
						)
					);

					 woocommerce_wp_radio( array(
						 'id'            => 'combos_option',
						 'name'            => 'combos_option',
						 'label'         => __('Products', 'tpwcp'),
						 'options'       => array(
							 'One'    => '1 Product &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
							 'Two'    => '2 Products &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
							 'Three'  => '3 Products &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;',
							 'Four'   => '4 Products'
						 ),
						 'value'         => $combos_option
					 ) );
				?>
				</div>
				<?php
				if($auto[0]=="yes"){
					if($combos_option=="One"){
				?>
				<table class="wp-list-table widefat fixed striped table-view-list posts">
					<thead>
					<tr>
						<td>KEY CODE.</td>
						<td>PRODUCT</td>
						<td>ACTIVATIONS</td>
						<td>DISPATCHED</td>
						<td>STATUS</td>
						<td>PRIORITY</td>
					</tr>
					</thead>
					<tbody>
					<?php
					$external_server=get_waolm_client_option('externalserver');
					if(empty($external_server)){//tenemos servidor local obtener información mediante mysql
						$content=return_local_server_keys($sku);
						$claves=json_decode(strip_tags($content),true);
						//$claves = array("0"=>"nada","1"=>"masomenos","2"=>"todo",);
					}else{//servidor es externo. Obtener datos mediante json.
						//$home=get_option('home');
						$external_server.="/jsonwaolm?sku=".$sku."&action=givememykeys"; // url de la pagina que queremos obtener  
						$url_content = '';  
						$file = @fopen($external_server, 'r');  
						if($file){  
						//if(false){  
						  while(!feof($file)) {  
							$url_content .= @fgets($file, 4096);  
						  }
						  $claves=json_decode(strip_tags($url_content),true);
						  fclose ($file);  
						}  
					}//fin de external_server
					//echo "<tr><td>".$external_server."</td></tr>";
					foreach($claves as $clave){ // por cada post_id encontrado
					?>
					<tr>
						<td><?php echo $clave['clave']//->;?></td>
						<td width="20%"><?php echo $clave['product']; ?></td>
						<td><?php echo $clave['activations']; ?></td>
						<td><?php echo $clave['dispatched'];?></td>
						<td><?php echo $clave['status'];?></td>
						<td><?php echo $clave['priority'];?></td>
					</tr>
					<?php
					}//fin de for bucle por cada llave
					?>
					</tbody>
				</table>
				<?php
					}else{//else if combos option one
						switch ($combos_option){
							case "Two": 
								$k=2;
								break;
							case "Three": 
								$k=3;
								break;
							case "Four": 
								$k=4;
								break;
						}//fin de switch
						$external_server=get_waolm_client_option('externalserver');
						if(empty($external_server)){//tenemos servidor local obtener información mediante mysql
							$resultados=json_decode(return_local_products_combo(),true);//Ahora en waolm-client-functions.php
						}else{
							$home=get_option('home');
							$external_server.="/jsonwaolm?sku=".$sku."&action=givemecomboproducts"; // url de la pagina que queremos obtener  
							$url_content = '';  
							$file = @fopen($external_server, 'r');  
							if($file){  
							//if(false){  
								while(!feof($file)) {  
									$url_content .= @fgets($file, 4096);  
								}
								$resultados=json_decode(strip_tags($url_content),true);
								fclose ($file); 
							}  
						}
						//print_r($resultados);
						$opciones=array();
						$opciones['']='No se ha seleccionado :(';
						foreach($resultados as $r){
							$opciones[$r['sku']]=$r['post_title'];
						}//fin foreach
						$prod=get_post_meta($name->ID,'_combo_products',true);
						for($j=0;$j<$k;$j++){
							$id_1 = "combo_product".$j;
							$label_1 = "Product ".($j+1);
							//$opciones = array('1'=>'uno','2'=>'dos','3'=>'tres');
							//$args = array( 'posts_per_page' => 200, 'post_status' => 'publish', 'post_type' => 'product' );
							//$postslist = new WP_Query( $args );
							woocommerce_wp_select(
								array(
									'id'		=> $id_1,
									'label'		=> __( $label_1, 'waolicensemanager' ),
									'desc_tip'	=> true,
									'description'	=> __( 'Select a woocommerce single product', 'waolicensemanager' ),
									'value'		=> $prod[$j],
									'options'	=> $opciones
								)
							);
							
						}//fin for
					}//fin if combos option one
				}//fin si autodispatch yes (fin de tabla)
				?>
				<div><hr>
				<?php
				if($combos_option=="One"){
					$auto=get_post_meta($name->ID,'_download_link');
					woocommerce_wp_text_input(
						array(
							'id'		=> 'download_link',
							'label'		=> __( 'Path for manual and download of this product', 'waolicensemanager' ),
							'type'		=> 'text',
							'value'		=> $auto[0],
							'desc_tip'	=> true,
							'description'	=> __( 'Write the path URL for manuals and downloads including language (Ex: <c style="color:yellow;">de/windows-11-pro/</c>)', 'waolicensemanager' )
						)
					);

					$auto=get_post_meta($name->ID,'_product_name');
					woocommerce_wp_text_input(
						array(
							'id'		=> 'product_name',
							'label'		=> __( 'Friendly Name for keys table', 'waolicensemanager' ),
							'placeholder'   => $name->post_title,
							'value'		=> $auto[0],
							'type'		=> 'text',
							'desc_tip'	=> true,
							'description'	=> __( 'The product name as will showed in the invoice.', 'waolicensemanager' )
						)
					);
				}//fin de combos option one
				?>
				</div><hr>
				<input type="submit" name="save" id="publish" class="button button-primary button-large" style="margin-bottom:20px;" value="Update">
			</div>
		</div>
	<?php 
	} // function end

/** 
* Save the custom fields using CRUD method 
* @param $post_id 
* @since 1.0.0 
*/
	public function save_fields( $post_id ) {
		$product = wc_get_product( $post_id );
		// Save the autodispatch_option setting 
		$autodispatch_option = isset( $_POST['autodispatch_option'] ) ? 'yes' : 'no';
		$auto=get_post_meta($post_id,'_autodispatch_option',true);
		$combos_option = isset( $_POST['combos_option'] ) ? $_POST['combos_option'] : '';
		$download_link = isset( $_POST['download_link'] ) ? $_POST['download_link'] : '';
			if($download_link<>"" AND substr($download_link, -1)<>'/'){$download_link.='/';}//forzamos slash al final
			if(substr($download_link, 0 ,1)=='/'){$download_link=substr($download_link, 1);}//forzamos quitar slash al principio
		$product_name = isset( $_POST['product_name'] ) ? $_POST['product_name'] : '';
		global $wpdb;
		if($combos_option<>"One"){
			switch ($combos_option){
				case "Two": 
					$k=2;
					break;
				case "Three": 
					$k=3;
					break;
				case "Four": 
					$k=4;
					break;
			}//fin de switch
			
			for($l=0;$l<=$k-1;$l++){
				$combo_product="combo_product".$l;
				$array_products[] = isset( $_POST[$combo_product] ) ? $_POST[$combo_product] : '';
				//$array_products[]=sanitize_text_field($paso);
			}//end for
			$product->update_meta_data( '_combo_products', $array_products  ); //Los skus (codigos) de producto en array
		}
		if($autodispatch_option=="yes"&&$auto=="yes"){
			$rotation = isset( $_POST[$rotation] ) ? $_POST[$rotation] : '';
		}//fin if autodispatch_option
		$product->update_meta_data( '_autodispatch_option', sanitize_text_field( $autodispatch_option ) );
		$product->update_meta_data( '_combos_option', sanitize_text_field( $combos_option ) );//one, two, four
		$product->update_meta_data( '_download_link', sanitize_text_field( $download_link ) );
		$product->update_meta_data( '_product_name', sanitize_text_field( $product_name ) );
		$product->save();
	}// function end

    }// fin de clase
}// fin de si existe clase


